



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>《天书夜读：从汇编语言到windows内核编程》八 文件操作与注册表操作</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">《天书夜读：从汇编语言到windows内核编程》八 文件操作与注册表操作</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-04 18:36:02 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>1）Windows运用程序的文件与注册表操作进入R0层之后，都有对应的内核函数实现。在windows内核中，无论打开的是文件、注册表或者设备，都需要使用InitializeObjectAttributes来初始化一个OBJECT_ATTRIBUTES结构体：</p>
<div>
<pre class="prettyprint linenums"> VOID  InitializeObjectAttributes(
     [out]    POBJECT_ATTRIBUTES InitializedAttributes,    //OBJECT_ATTRIBUTES的指针
     [in]    PUNICODE_STRING ObjectName,    //对象名字字符串（文件则为路径）
     [in]    ULONG Attributes,    //填OBJ_CASE_INSENSITIVE（不区分大小写）|OBJ_KERNEL_HANDLE（内核句柄）
     [in]    HANDLE RootDirectory,    //填NULL
     [in]  PSECURITY_DESCRIPTOR SecurityDescriptor    //安全描述符，使用内核句柄（OBJ_KERNEL_HANDLE）时忽略
 );</pre>
</div>
<p>2）打开文件（ZwCreateFile）和关闭文件（ZwClose）：</p>
<div>
<pre class="prettyprint linenums"> NTSTATUS ZwCreateFile(
     [Out]  PHANDLE FileHandle,//文件句柄指针，它指向打开的文件句柄值
     [In]  ACCESS_MASK DesiredAccess,//申请权限，读写操作，修改文件属性，删除文件等
     [In]  POBJECT_ATTRIBUTES ObjectAttributes,//对象描述，见八（1）
     [Out]  PIO_STATUS_BLOCK IoStatusBlock,//操作结果结构，成功或失败，失败原因
     [In]  PLARGE_INTEGER AllocationSize,//很少使用，置为NULL
     [In]  ULONG FileAttributes,//新建立的文件属性，一般为FILE_ATTRUBITE_NORMAL
     [In]  ULONG ShareAccess,//共享访问，本次打开后允许其他对象以什么方式打开
     [In]  ULONG CreateDisposition,//本次打开意图，如新建或者覆盖
     [In]  ULONG CreateOptions,//打开选项，如打开文件还是目录，同步打开还是异步打开
     [In]  PVOID EaBuffer,//置为NULL
     [In]  ULONG EaLength//置为0
 );</pre>
</div>
<p>　　示例：</p>
<div>
<pre class="prettyprint linenums"> HANDLE file_handle = NULL;//要返回的文件句柄
 NTSTATUS status;//返回值

 //首先初始化含有文件路径的OBJECT_ATTRIBUTES
 OBJECT_ATTRIBUTES object_attributes;
 UNICODE_STRING ufile_name = RTL_CONSTANT_STRING(L"\\??\\c:\\a.dat");
 //要使用对象路径，“C:”是符号链接对象，一般在“\\??\\”
 InitializeObjectAttributes(
     &amp;object_attributes,
     &amp;ufile_name,
     OBJ_CASE_INSENSITIVE|OBJ_KERNEL_HANDLE,
     NULL,
     NULL);
 //以OPEN_IF方式打开
 IO_STATUS_BLOCK io_status;
 status = ZwCreateFile(
     &amp;file_handle,
     GENERIC_READ|GENERIC_WRITE,//普通读写
     &amp;object_attributes,
     &amp;io_status,
     NULL,
     FILE_ATTRIBUTE_NORMAL,//新建立文件为为普通属性
     FILE_SHARE_READ,//打开文件到关闭前，允许被其他进程已读方式打开
     FILE_OPEN_IF,//文件存在则打开，不存在则新建
     FILE_NON_DIRECTORY_FILE|FILE_RANDOM_ACCESS|FILE_SYNCHRONOUS_IO_NONALERT,//打开文件，随机存取打开，同步打开
     NULL,
     );</pre>
</div>
<p>　　&nbsp;内核文件句柄的关闭不需要在同一个进程当中，调用ZwClose(file_handle);即可</p>
<p>3）文件读（ZwReadFile）和文件写（ZwWriteFile），方法对称，只不过参数输入输出方向不同。</p>
<div>
<pre class="prettyprint linenums"> NTSTATUS  ZwReadFile(
     IN  HANDLE  FileHandle,//文件句柄，由ZwFileCreate获取
     IN  HANDLE  Event  OPTIONAL,//事件，用于异步完成读。同步置位NULL
     IN  PIO_APC_ROUTINE  ApcRoutine  OPTIONAL,//回调例程，用于异步完成读
     IN  PVOID  ApcContext  OPTIONAL,
    OUT  PIO_STATUS_BLOCK  IoStatusBlock, //返回结果状态
    OUT  PVOID  Buffer, //缓冲区，读成功则内容在该缓冲区
     IN  ULONG  Length,//描述缓冲区长度，即试图读取文件的长度
     IN  PLARGE_INTEGER  ByteOffset  OPTIONAL,//读取内容在文件中的起始偏移量
     IN  PULONG  Key  OPTIONAL//附加信息，一般置为NULL
 );</pre>
</div>
<p>　　ZwWriteFile参数与它类似。</p>
<p>4）内核编程读取HKEY_LOCAL_MACHINE时使用路径“\Registry\Machine”，而读取HKEY_USERS时使用“\Registry\User”，由于内核程序不是面向某个“当前用户”的，所以，没有HKEY_CURRENT_USER和HKEY_CLASSES_ROOT对应的路径。</p>
<p>5）打开注册表（ZwOpenKey或者ZwCreateKey）、读注册表（ZwQueryValueKey）和写注册表（ZwSetValueKey）：</p>
<div>
<pre class="prettyprint linenums"> ZwOpenKey原型：
 NTSTATUS ZwOpenKey(
     OUT  PHANDLE  KeyHandle,//返回的句柄
     IN  ACCESS_MASK  DesiredAccess,//权限，如读、设置、生成子键、枚举子键权限
     IN  POBJECT_ATTRIBUTES  ObjectAttributes//指向OBJECT_ATTRIBUTES
     );

 ZwQueryValueKey原型：
 NTSTATUS ZwQueryValueKey(
     IN  HANDLE  KeyHandle,//句柄，由ZwOpenKey或ZwCreateKey取得
     IN  PUNICODE_STRING  ValueName,//要读取的键名
     IN  KEY_VALUE_INFORMATION_CLASS  KeyValueInformationClass,//读取信息的类型
    OUT  PVOID  KeyValueInformation,
     IN  ULONG  Length,//传入的KeyValueInformation的长度
    OUT  PULONG  ResultLength//返回实际需要的长度
     );</pre>
</div>
<p>　　KeyValueInformationClass有3种类型：KeyValueBaseInformation（基础信息：值名和类型）、KeyValueFullInformation（完整信息：值名、类型和数据）和KeyValuePartialInformation（局部信息：类型和数据）。值名是已知的，所以通常是使用KeyValuePartialInformation，此时，KeyValueInformation参数将返回一个KEY_VALUE_PARTIAL_INFOMATION的结构体的指针。它的原型为：</p>
<div>
<pre class="prettyprint linenums"> typedef struct _KEY_VALUE_PARTIAL_INFORMATION {
   ULONG  TitleIndex;    //忽略
   ULONG  Type;        //数据类型（REG_BINARY（16进制）、REG_DWORD（4字节整数）、REG_SZ（以空结束的Unicode字符串））
   ULONG  DataLength;    //数据长度
   UCHAR  Data[];        //可变长度的数据
 } KEY_VALUE_PARTIAL_INFORMATION, *PKEY_VALUE_PARTIAL_INFORMATION;

 ZwSetValueKey原型（写入的键存在怎覆盖，不存在则新建）：
 NTSTATUS ZwSetValueKey(
     IN  HANDLE  KeyHandle,
     IN  PUNICODE_STRING  ValueName,
     IN  ULONG  TitleIndex  OPTIONAL,//始终填入0
     IN  ULONG  Type,
     IN  PVOID  Data,//要写入的数据起始地址
     IN  ULONG  DataSize//要写入的长度
 );</pre>
</div>
<p>　　示例：</p>
<div>
<pre class="prettyprint linenums"> #define  MEM_TAG  ‘MyTt’
 //读取windws目录，在HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion中的SystemRoot键中
 //要读取的键名
 UNICODE_STRING my_key_name = RTL_CONSTANT_STRING(L"SystemRoot");
 //用来试探大小的key_info
 KEY_VALUE_PARTIAL_INFORMATION key_info;
 //最后实际用到的key_info指针。内存分配在堆中
 PKEY_VALUE_PARTIAL_INFORMATION ac_key_info;
 ULONG ac_lenth;

 HANDLE my_key = NULL;
 NTSTATUS status;

 //定义要获取的路径
 UNICODE_STRING my_key_path = RTL_CONSTANT_STRING(L"\\Registry\\Machine\\SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion");
 OBJECT_ATTRIBUTES my_obj_attr = {};

 //初始化OBJECT_ATTRIBUTES
 InitializeObjectAttributes(
     &amp;my_obj_attr,
     &amp;my_key_path,
     OBJ_CASE_INSENSITIVE,
     NULL,
     NULL);

 //打开KEY
 status = ZwOpenKey(&amp;my_key,KEY_READ,&amp;my_obj_attr);
 if ( !NT_SUCCESS(status) )
 {
     //处理失败
 }

 //读取KEY的值
 status = ZwQueryValueKey(
     my_key,
     &amp;my_key_name,
     KeyValuePartialInformation,
     &amp;key_info,
     sizeof(KEY_VALUE_PARTIAL_INFORMATION),
     &amp;ac_lenth);
 if ( !NT_SUCCESS(status) &amp;&amp;
     status != STATUS_BUFFER_TOO_SMALL &amp;&amp;
     status != STATUS_BUFFER_OVERFLOW)
 {
     //处理失败
 }

 //如果没有失败，则分配存储空间不足，再次获取
 ac_key_info = (PKEY_VALUE_PARTIAL_INFORMATION)
     ExAllocatePoolWithTag(NonPagedPool,ac_lenth,MEM_TAG);

 if ( ac_key_info == NULL )
 {
     status = STATUS_INSUFFICIENT_RESOURCES;
     //错误处理
 }

 status = ZwQueryValueKey(
     my_key,
     &amp;my_key_name,
     KeyValuePartialInformation,
     ac_key_info,
     ac_lenth,
     &amp;ac_lenth);
 if ( !NT_SUCCESS(status) )
 {
     //处理失败
 }
 //成功读取数据到ac_key_info-&gt;data中</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8k1vx69.html">Android 6&period;0 运行时权限处理完全解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8eoxkzq.html">pandas筛选0&comma;3&comma;6开头的行</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx523z8.html">Nginx反向代理配置可跨域</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvjnjzq.html">zoj 3717 - Balloon&lpar;2-SAT&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mgve28.html">Merge和Rebase在Git中的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx0opdq.html">使用php作linux自动执行脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydrrd2q.html">【阿里云产品公测】在Laravel4框架中使用阿里云ACE的缓存服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0v7n4q.html">gson小练习之嵌套复杂数据解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mwyxeq.html">go与json</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mkgekq.html">js 计算某年某周日期范围</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oxzen9.html">模块工具类--utils</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj02nk8.html">Xamarin&plus;Prism开发之&period;net standard化</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gekz2e8.html">Java Draw</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me54poq.html">jersey在 spring boot 添加 packages 扫描路径支持</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pej548.html">&period;net基础系列</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y0mjg8.html">python学习笔记之线程、进程和协程（第八天）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4el0z9.html">redis持久化数据的机制&mdash;&mdash;转发</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7oyovg8.html">解析img图片没找到onerror事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllgmzxq.html">调用DATASNAP&plus;FIREDAC的远程方法有时会执行二次SQL或存储过程的BUG（转永喃兄）</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1lv569.html">JavaScript RegExp Object　正则表达式入门</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q1kygkz9.html">SQL Server Compact&sol;SQLite Toolbox 使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jg7lw8.html">Nginx平滑升级源码分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ey3pnk9.html">ubuntu mount u盘以及cp拷贝文件夹</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z0mx19.html">Sqlite常用sql语句</a>
			</li>
						<li><a href="https://www.batexi.com/a/8merndpq.html">wpf 制作必输项的&ast;标记</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkzk0v8.html">一份传世典文：十年编程（Teach Yourself Programming in Ten Years）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z072k9.html">TQ2440--nandflash（K9F2G08U0A）驱动编写</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzdpjw8.html">BootStrap Table和Mybatis Plus实现服务端分页</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mkee38.html">PHP的Session机制</a>
			</li>
						<li><a href="https://www.batexi.com/a/8merke0q.html">&lbrack;Bayes&rsqb; Variational Inference for Bayesian GMMs</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
